Index: /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk	(revision 82898)
+++ /trunk/src/VBox/Additions/x11/VBoxClient/Makefile.kmk	(revision 82899)
@@ -114,86 +114,4 @@
 	$(PATH_ROOT)/src/VBox/ImageMounter/vboximg-mount
   endif
-  ifdef VBOX_WITH_LIBGVFS
-   VBOX_VBOXCLIENT_GVFS_PATH := gvfs-1.43.1
-   VBoxClient_SOURCES += \
-	clipboard-gvfs.c \
-   VBoxClient_SOURCES += \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsafpconnection.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsafpserver.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsafputils.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsafpvolume.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsbackend.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsdaemonutils.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobcopy.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobpush.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobunmountmountable.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfschannel.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsdaemon.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjob.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobcloseread.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobclosewrite.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobcreatemonitor.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobdbus.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobdelete.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobenumerate.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjoberror.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobmakedirectory.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobmakesymlink.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobmount.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobmountmountable.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobmove.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobopenforread.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobopenforwrite.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobopeniconforread.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobpollmountable.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobprogress.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobpull.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobqueryattributes.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobqueryfsinfo.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobqueryinfo.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobqueryinforead.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobqueryinfowrite.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobread.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobseekread.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobseekwrite.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobsetattribute.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobsetdisplayname.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobsource.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobstartmountable.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobstopmountable.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobtrash.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobtruncate.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobunmount.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsjobwrite.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfskeyring.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsmonitor.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfsreadchannel.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon/gvfswritechannel.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsmonitorimpl.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gmountoperationdbus.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gmountsource.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gmountspec.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gmounttracker.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsdaemonprotocol.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsfileinfo.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsicon.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsmountinfo.c \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/common/gvfsutils.c
-   VBoxClient_SOURCES += \
-	${VBOX_VBOXCLIENT_GVFS_PATH}/out/common/gvfsdbus.c
-   VBoxClient_CFLAGS  += -Wno-sign-compare -Wno-unused-parameter -Wno-pedantic
-   VBoxClient_INCS    += \
- 	${VBOX_VBOXCLIENT_GVFS_PATH}/common \
- 	${VBOX_VBOXCLIENT_GVFS_PATH}/daemon \
- 	${VBOX_VBOXCLIENT_GVFS_PATH}/out \
- 	${VBOX_VBOXCLIENT_GVFS_PATH}/out/common \
- 	/usr/include/glib-2.0 \
- 	/usr/lib/x86_64-linux-gnu/glib-2.0/include \
- 	/usr/include/gio-unix-2.0
-   VBoxClient_LIBS += \
-	gio-2.0 \
-	glib-2.0 \
-	gobject-2.0
-  endif
  endif
 endif